Docker Image for SafeChat
=========================

For a running example see: https://safechat.ch


Run SafeChat
------------

Safechat exposts port 8080 as it is based on [mwaeckerlin/php-fpm].

You need a [mysql] database (less than version 8). The hostname must be `mysql` and the root password must be set in `MYSQL_ENV_MYSQL_ROOT_PASSWORD`, e.g.

```bash
docker run -d --name safechat-mysql -e MYSQL_ROOT_PASSWORD=$(pwgen 20 1) mysql:5
docker run -d --name safechat -p 8005:8080 --link safechat-mysql:mysql mwaeckerlin/safechat
```


Build Docker Image
------------------

Install safechat into path `docker/usr`, then build the image, e.g.:

```bash
cd ~/git/safechat
./bootstrap.sh -t "all install" --prefix=$(pwd)/docker/usr
docker build --rm --force-rm -t mwaeckerlin/safechat docker
```


[mwaeckerlin/php-fpm]: https://hub.docker.com/r/mwaeckerlin/php-fpm "image on docker hub"
[mysql]:               https://hub.docker.com/_/mysql "image on docker hub"
